#include <os.h>
#include "xorrand.h"

static uint32_t xorshift32x;

void sxorshift32(uint32_t seed){
    xorshift32x = seed;
}

uint32_t xorshift32() {
  xorshift32x ^= xorshift32x << 13;
  xorshift32x ^= xorshift32x >> 17;
  xorshift32x ^= xorshift32x << 5;
  return xorshift32x;
}

uint32_t xorshift128() {
  static uint32_t x = 123456789;
  static uint32_t y = 362436069;
  static uint32_t z = 521288629;
  static uint32_t w = 88675123;

  uint32_t t = x ^ (x << 11);
  x = y; y = z; z = w;
  w ^= (w >> 19) ^ t ^ (t >> 8);

  return w;
}
